Loading...
Searching...
No Matches
Exiv2::DataValue Class Reference

Value for an undefined data type. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::DataValue:
[legend]

## Public Types

typedef std::auto_ptr< DataValue > | AutoPtr
| Shortcut for a DataValue auto pointer.
Public Types inherited from Exiv2::Value
typedef std::auto_ptr< Value > | AutoPtr
| Shortcut for a Value auto pointer.

## Public Member Functions

| DataValue (TypeId typeId=undefined)
| DataValue (const byte *buf, long len, ByteOrder byteOrder=invalidByteOrder, TypeId typeId=undefined)
Manipulators
virtual int | read (const byte *buf, long len, ByteOrder byteOrder=invalidByteOrder)
| Read the value from a character buffer.
virtual int | read (const std::string &buf)
| Set the data from a string of integer values (e.g., "0 1 2 3")
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()
| Virtual destructor.
virtual int | setDataArea (const byte *buf, long len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual long | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors

AutoPtr | clone () const
virtual long | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const
| Write value to a character data buffer.
virtual long | count () const
| Return the number of components of the value.
virtual long | size () const
| Return the size of the value in bytes.
virtual std::ostream & | write (std::ostream &os) const
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
virtual std::string | toString (long n) const
| Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.
virtual long | toLong (long n=0) const
| Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.
virtual float | toFloat (long n=0) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
virtual Rational | toRational (long n=0) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

## Additional Inherited Members

Static Public Member Functions inherited from Exiv2::Value
static AutoPtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
Protected Member Functions inherited from Exiv2::Value
Value & | operator= (const Value &rhs)
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
Protected Attributes inherited from Exiv2::Value
bool | ok_
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Value for an undefined data type.

## Member Function Documentation

## copy()

long Exiv2::DataValue::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  | const

virtual

Write value to a character data buffer.

Note
  The byte order is required by the interface but not used by this method, so just use the default.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Parameters

  buf | Data buffer to write to.
  byteOrder | Byte order. Not needed.

Returns
  Number of characters written.

Implements Exiv2::Value.

## count()

long Exiv2::DataValue::count | ( |  | ) | const

virtual

Return the number of components of the value.

Implements Exiv2::Value.

References size().

## read() [1/2]

int Exiv2::DataValue::read | ( | const byte * | buf,
|  | long | len,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  |

virtual

Read the value from a character buffer.

Note
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters

  buf | Pointer to the data buffer to read from
  len | Number of bytes in the data buffer
  byteOrder | Byte order. Not needed.

Returns
  0 if successful.

Implements Exiv2::Value.

## read() [2/2]

int Exiv2::DataValue::read | ( | const std::string & | buf | ) |

virtual

Set the data from a string of integer values (e.g., "0 1 2 3")

Implements Exiv2::Value.

## size()

long Exiv2::DataValue::size | ( |  | ) | const

virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

Referenced by count().

## toFloat()

float Exiv2::DataValue::toFloat | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toLong()

long Exiv2::DataValue::toLong | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a long. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toRational()

Rational Exiv2::DataValue::toRational | ( | long | n = `0` | ) | const

virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toString()

std::string Exiv2::DataValue::toString | ( | long | n | ) | const

virtual

Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.

Reimplemented from Exiv2::Value.

References Exiv2::Value::ok_.

## write()

std::ostream & Exiv2::DataValue::write | ( | std::ostream & | os | ) | const

virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp